// Copyright (C) 2021  Aravinth Manivannan <realaravinth@batsense.net>
// SPDX-FileCopyrightText: 2023 Aravinth Manivannan <realaravinth@batsense.net>
//
// SPDX-License-Identifier: AGPL-3.0-or-later

use sailfish::TemplateOnce;

use crate::pages::errors::ErrorPage;

#[derive(Clone, TemplateOnce)]
#[template(path = "auth/sudo/index.html")]
pub struct SudoPage<'a> {
    url: &'a str,
    title: &'a str,
    error: Option<ErrorPage<'a>>,
}

pub const PAGE: &str = "Confirm Access";

impl<'a> SudoPage<'a> {
    pub fn new(url: &'a str, title: &'a str) -> Self {
        Self {
            url,
            title,
            error: None,
        }
    }

    pub fn set_err(&mut self, err_title: &'a str, message: &'a str) {
        self.error = Some(ErrorPage::new(err_title, message));
    }
}
